var URLRequestDefinition = (function () {
  var def = {
    initialize: function () {
      this._url = null;
      this._method = 'GET';
      this._data = null;
      this._contentType = 'application/x-www-form-urlencoded';
    },

    get contentType() {
      return this._contentType;
    },
    set contentType(val) {
      this._contentType = val;
    },
    get data() {
      return this._data;
    },
    set data(val) {
      this._data = val;
    },
    get method() {
      return this._method;
    },
    setMethod: function (val) {
      this._method = val;
    },
    get requestHeaders() {
      return this._requestHeaders;
    },
    setRequestHeaders: function (val) {
      this._requestHeaders = val;
    },
    get url() {
      return this._url;
    },
    set url(val) {
      this._url= val;
    },
  };

  var desc = Object.getOwnPropertyDescriptor;

  def.__glue__ = {
    native: {
      instance: {
        contentType: desc(def, 'contentType'),
        data: desc(def, 'data'),
        method: desc(def, 'method'),
        requestHeaders: desc(def, 'requestHeaders'),
        setMethod: def.setMethod,
        setRequestHeaders: def.setRequestHeaders,
        url: desc(def, 'url')
      }
    }
  };

  return def;
}).call(this);
